#include <windows.h>
#include <stdio.h>
#include <ctype.h>

void printresult(long arg);

char usage[]=
"chres - CHange RESolution. Freeware\n"
"(C) 2004-2012, DJ-Andrey-sXe\n"
"http://dj-andrey.ru\n\n"
"Usage variants:\n\n"
"  1.  chres -d\n"
"  2.  chres x y\n"
"  3.  chres x y bpp\n"
"  4.  chres x y bpp hertz\n";

int main(int argc, char *argv[])
{
  long rval;
  DEVMODE mode;

  memset( &mode, 0, sizeof(DEVMODE) );
  mode.dmSize = sizeof(DEVMODE);
  mode.dmDriverExtra = 0;
  mode.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT;

  switch ( argc )
  {
    case 1:
      puts(usage); return 0;
    case 2:
      if ( argv[1][0] == '/' || argv[1][0] == '-' )
        switch ( argv[1][1] )
        {
          case '?':
          case 'h':
          case 'H':
              puts(usage); return 0;
          case 'd':          
          case 'D':
            // -d restore default mode after dynamic switch
            rval = ChangeDisplaySettings ( NULL, 0 );
            printresult(rval); break;
          default:
            printf("\nERROR! Unknown option: %c\n\n", argv[1][1]);
            puts(usage); return 0;
        }//switch
      puts(usage); return 0;
    case 3:
      mode.dmPelsWidth  = atoi(argv[1]);
      mode.dmPelsHeight = atoi(argv[2]);
      rval = ChangeDisplaySettings ( &mode, CDS_RESET );
      printresult(rval); break;
    case 4:
      mode.dmPelsWidth  = atoi(argv[1]);
      mode.dmPelsHeight = atoi(argv[2]);
      mode.dmBitsPerPel = atoi(argv[3]);
      mode.dmFields |= DM_BITSPERPEL;
      rval = ChangeDisplaySettings ( &mode, CDS_RESET );
      printresult(rval); break;
    case 5:
      mode.dmPelsWidth  = atoi(argv[1]);
      mode.dmPelsHeight = atoi(argv[2]);
      mode.dmBitsPerPel = atoi(argv[3]);
      mode.dmDisplayFrequency = atoi(argv[4]);
      mode.dmFields |= DM_BITSPERPEL | DM_DISPLAYFREQUENCY;
      rval = ChangeDisplaySettings ( &mode, CDS_RESET );
      printresult(rval); break;
    default:
      puts(usage);
  }//switch

  return 0; 

}

void printresult(long arg)
{
  if ( arg == DISP_CHANGE_SUCCESSFUL )
    puts("Ok\n");
  else
    puts("Failed\n");
}
